// UBPile Admin Page -- Plugins

Class.add( Page.Admin, {
	
	ctype_labels: {
		text: "Текстовое поле",
		textarea: "Текстовое окно",
		checkbox: "Флажок",
		hidden: "Скрытый",
		select: "Меню"
	},
	
	gosub_plugins: function(args) {
		// show plugin list
		this.div.removeClass('loading');
		app.setWindowTitle( "Плагины" );
		
		var size = get_inner_window_size();
		var col_width = Math.floor( ((size.width * 0.9) + 500) / 6 );
		
		var html = '';
		
		this.plugins = app.plugins;
		
		html += this.getSidebarTabs( 'plugins',
			[
				['activity', "Журнал активности"],
				['api_keys', "API-ключи"],
				['categories', "Категории"],
				['plugins', "Плагины"],
				['servers', "Серверы"],
				['users', "Пользователи"]
			]
		);
		
		var cols = ['Имя плагина', 'Автор', '# Кол-во событий', 'Создан', 'Модифицирован', 'Действия'];
		
		// html += '<div style="padding:5px 15px 15px 15px;">';
		html += '<div style="padding:20px 20px 30px 20px">';
		
		html += '<div class="subtitle">';
			html += 'Плагины';
			// html += '<div class="clear"></div>';
		html += '</div>';
		
		// sort by title ascending
		this.plugins = app.plugins.sort( function(a, b) {
			// return (b.title < a.title) ? 1 : -1;
			return a.title.toLowerCase().localeCompare( b.title.toLowerCase() );
		} );
		
		var self = this;
		html += this.getBasicTable( this.plugins, cols, 'плагинов', function(plugin, idx) {
			var actions = [
				'<span class="link" onMouseUp="$P().edit_plugin('+idx+')"><b>Редактировать</b></span>',
				'<span class="link" onMouseUp="$P().delete_plugin('+idx+')"><b>Удалить</b></span>'
			];
			
			var plugin_events = find_objects( app.schedule, { plugin: plugin.id } );
			var num_events = plugin_events.length;
			
			var tds = [
				'<div class="td_big"><a href="#Admin?sub=edit_plugin&id='+plugin.id+'">' + self.getNicePlugin(plugin, col_width) + '</a></div>',
				self.getNiceUsername(plugin, true, col_width),
				num_events ? commify( num_events ) : '(Ничего)',
				'<span title="'+(new Date(plugin.created * 1000)).toLocaleString()+'">'+(new Date(plugin.created * 1000)).toLocaleDateString()+'</span>',
				'<span title="'+(new Date(plugin.modified * 1000)).toLocaleString()+'">'+(new Date(plugin.created * 1000)).toLocaleDateString()+'</span>',
				actions.join(' | ')
			];
			
			if (!plugin.enabled) {
				if (tds.className) tds.className += ' '; else tds.className = '';
				tds.className += 'disabled';
			}
			
			return tds;
		} );
		
		html += '<div style="height:30px;"></div>';
		html += '<center><table><tr>';
			html += '<td><div class="button" style="width:140px;" onMouseUp="$P().edit_plugin(-1)"><i class="fa fa-plus-circle">&nbsp;&nbsp;</i>Добавить...</div></td>';
		html += '</tr></table></center>';
		
		html += '</div>'; // padding
		html += '</div>'; // sidebar tabs
		
		this.div.html( html );
	},
	
	edit_plugin: function(idx) {
		// jump to edit sub
		if (idx > -1) Nav.go( '#Admin?sub=edit_plugin&id=' + this.plugins[idx].id );
		else Nav.go( '#Admin?sub=new_plugin' );
	},
	
	delete_plugin: function(idx) {
		// delete key from search results
		this.plugin = this.plugins[idx];
		this.show_delete_plugin_dialog();
	},
	
	show_delete_plugin_dialog: function() {
		// delete selected plugin
		var plugin = this.plugin;
		
		// check for events first
		var plugin_events = find_objects( app.schedule, { plugin: plugin.id } );
		var num_events = plugin_events.length;
		if (num_events) return app.doError("К сожалению, вы не можете удалить плагин, которому назначены события.");
		
		// proceed with delete
		var self = this;
		app.confirm( '<span style="color:red">Удалить плагин</span>', "Вы уверены, что хотите удалить плагин <b>"+plugin.title+"</b>? Отменить это действие невозможно.", "Удалить", function(result) {
			if (result) {
				app.showProgress( 1.0, "Удаление плагина..." );
				app.api.post( 'app/delete_plugin', plugin, function(resp) {
					app.hideProgress();
					app.showMessage('success', "Плагин '"+self.plugin.title+"' был успешно удален.");
					// self.gosub_plugins(self.args);
					
					Nav.go('Admin?sub=plugins', 'force');
				} );
			}
		} );
	},
	
	gosub_new_plugin: function(args) {
		// create new plugin
		var html = '';
		app.setWindowTitle( "Новый плагин" );
		this.div.removeClass('loading');
		
		html += this.getSidebarTabs( 'new_plugin',
			[
				['activity', "Журнал активности"],
				['api_keys', "API-ключи"],
				['categories', "Категории"],
				['plugins', "Плагины"],
				['new_plugin', "Новый плагин"],
				['servers', "Серверы"],
				['users', "Пользователи"]
			]
		);
		
		html += '<div style="padding:20px;"><div class="subtitle">Добавить новый плагин</div></div>';
		
		html += '<div style="padding:0px 20px 50px 20px">';
		html += '<center><table style="margin:0;">';
		
		if (this.plugin_copy) {
			this.plugin = this.plugin_copy;
			delete this.plugin_copy;
		}
		else {
			this.plugin = { params: [], enabled: 1 };
		}
		
		html += this.get_plugin_edit_html();
		
		// buttons at bottom
		html += '<tr><td colspan="2" align="center">';
			html += '<div style="height:30px;"></div>';
			
			html += '<table><tr>';
				html += '<td><div class="button" style="width:120px; font-weight:normal;" onMouseUp="$P().cancel_plugin_edit()">Отмена</div></td>';
				html += '<td width="50">&nbsp;</td>';
				html += '<td><div class="button" style="width:120px;" onMouseUp="$P().do_new_plugin()"><i class="fa fa-plus-circle">&nbsp;&nbsp;</i>Создать</div></td>';
			html += '</tr></table>';
			
		html += '</td></tr>';
		html += '</table></center>';
		
		html += '</div>'; // table wrapper div
		html += '</div>'; // sidebar tabs
		
		this.div.html( html );
		
		setTimeout( function() {
			$('#fe_ep_title').focus();
		}, 1 );
	},
	
	cancel_plugin_edit: function() {
		// cancel edit, nav back to plugin list
		Nav.go('Admin?sub=plugins');
	},
	
	do_new_plugin: function(force) {
		// create new plugin
		app.clearError();
		var plugin = this.get_plugin_form_json();
		if (!plugin) return; // error
		
		// pro-tip: embed id in title as bracketed prefix
		if (plugin.title.match(/^\[(\w+)\]\s*(.+)$/)) {
			plugin.id = RegExp.$1;
			plugin.title = RegExp.$2;
		}
		
		this.plugin = plugin;
		
		app.showProgress( 1.0, "Создание плагина..." );
		app.api.post( 'app/create_plugin', plugin, this.new_plugin_finish.bind(this) );
	},
	
	new_plugin_finish: function(resp) {
		// new plugin created successfully
		app.hideProgress();
		
		Nav.go('Admin?sub=plugins');
		
		setTimeout( function() {
			app.showMessage('success', "Новый плагин был успешно создан.");
		}, 150 );
	},
	
	gosub_edit_plugin: function(args) {
		// edit plugin subpage
		var plugin = find_object( app.plugins, { id: args.id } );
		if (!plugin) return app.doError("Не удалось найти плагин с ID: " + args.id);
		
		// make local copy so edits don't affect main app list until save
		this.plugin = deep_copy_object( plugin );
		
		var html = '';
		app.setWindowTitle( "Плагин редактирования \"" + plugin.title + "\"" );
		this.div.removeClass('loading');
		
		html += this.getSidebarTabs( 'edit_plugin',
			[
				['activity', "Журнал активности"],
				['api_keys', "API-ключи"],
				['categories', "Категории"],
				['plugins', "Плагины"],
				['edit_plugin', "Редактировать плагин"],
				['servers', "Серверы"],
				['users', "Пользователи"]
			]
		);
		
		html += '<div style="padding:20px;"><div class="subtitle">Плагин редактирования &ldquo;' + plugin.title + '&rdquo;</div></div>';
		
		html += '<div style="padding:0px 20px 50px 20px">';
		html += '<center>';
		html += '<table style="margin:0;">';
		
		html += this.get_plugin_edit_html();
		
		html += '<tr><td colspan="2" align="center">';
			html += '<div style="height:30px;"></div>';
			
			html += '<table><tr>';
				html += '<td><div class="button" style="width:120px; font-weight:normal;" onMouseUp="$P().cancel_plugin_edit()">Отмена</div></td>';
				html += '<td width="50">&nbsp;</td>';
				html += '<td><div class="button" style="width:120px; font-weight:normal;" onMouseUp="$P().show_delete_plugin_dialog()">Удалить плагин...</div></td>';
				html += '<td width="50">&nbsp;</td>';
				html += '<td><div class="button" style="width:120px; font-weight:normal;" onMouseUp="$P().do_copy_plugin()">Копировать...</div></td>';
				html += '<td width="50">&nbsp;</td>';
				html += '<td><div class="button" style="width:130px;" onMouseUp="$P().do_save_plugin()"><i class="fa fa-floppy-o">&nbsp;&nbsp;</i>Сохранить</div></td>';
			html += '</tr></table>';
			
		html += '</td></tr>';
		
		html += '</table>';
		html += '</center>';
		html += '</div>'; // table wrapper div
		
		html += '</div>'; // sidebar tabs
		
		this.div.html( html );
	},
	
	do_copy_plugin: function() {
		// copy plugin to new
		app.clearError();
		var plugin = this.get_plugin_form_json();
		if (!plugin) return; // error
		
		delete plugin.id;
		delete plugin.created;
		delete plugin.modified;
		delete plugin.username;
		
		plugin.title = "Копия " + plugin.title;
		
		this.plugin_copy = plugin;
		Nav.go('Admin?sub=new_plugin');
	},
	
	do_save_plugin: function() {
		// save changes to existing plugin
		app.clearError();
		var plugin = this.get_plugin_form_json();
		if (!plugin) return; // error
		
		this.plugin = plugin;
		
		app.showProgress( 1.0, "Сохранение плагина..." );
		app.api.post( 'app/update_plugin', plugin, this.save_plugin_finish.bind(this) );
	},
	
	save_plugin_finish: function(resp, tx) {
		// existing plugin saved successfully
		var self = this;
		var plugin = this.plugin;
		
		app.hideProgress();
		app.showMessage('success', "Плагин успешно сохранен.");
		window.scrollTo( 0, 0 );
		
		// copy active jobs to array
		var jobs = [];
		for (var id in app.activeJobs) {
			var job = app.activeJobs[id];
			if ((job.plugin == plugin.id) && !job.detached) jobs.push( job );
		}
		
		// if the plugin was disabled and there are running jobs, ask user to abort them
		if (!plugin.enabled && jobs.length) {
			app.confirm( '<span style="color:red">Прервать работу</span>', "На данный момент" + ((jobs.length != 1) ? ' ' : ' ') + "активно " + jobs.length + " " + pluralize('задание', jobs.length) + " с использованием отключаемого плагина <b>"+plugin.title+"</b>. Вы хотите прервать " + ((jobs.length != 1) ? 'их' : 'его') + " сейчас?", "Прервать", function(result) {
				if (result) {
					app.showProgress( 1.0, "Прерывание " + pluralize('Задание', jobs.length) + "..." );
					app.api.post( 'app/abort_jobs', { plugin: plugin.id }, function(resp) {
						app.hideProgress();
						if (resp.count > 0) {
							app.showMessage('success', "На данный момент " + pluralize('задание', resp.count) + " " + ((resp.count != 1) ? ' ' : ' ') + "прервали успешно.");
						}
						else {
							app.showMessage('warning', "Ни одно задание не было прекращено. Вероятно, они завершились, пока диалог был открыт.");
						}
					} );
				} // clicked Abort
			} ); // app.confirm
		} // disabled + jobs
	},
	
	get_plugin_edit_html: function() {
		// get html for editing a plugin (or creating a new one)
		var html = '';
		var plugin = this.plugin;
		
		// Internal ID
		if (plugin.id && this.isAdmin()) {
			html += get_form_table_row( 'Плагин ID', '<div style="font-size:14px;">' + plugin.id + '</div>' );
			html += get_form_table_caption( "Внутренний идентификатор плагина, используемый для вызовов API. Это невозможно изменить." );
			html += get_form_table_spacer();
		}
		
		// plugin title
		html += get_form_table_row( 'Имя плагина', '<input type="text" id="fe_ep_title" size="35" value="'+escape_text_field_value(plugin.title)+'" spellcheck="false"/>' );
		html += get_form_table_caption( "Введите имя плагина. В идеале оно должно быть несколько коротким и будет использоваться как заголовок. Регист учитывается." );
		html += get_form_table_spacer();
		
		// plugin enabled
		html += get_form_table_row( 'Активный', '<input type="checkbox" id="fe_ep_enabled" value="1" ' + (plugin.enabled ? 'checked="checked"' : '') + '/><label for="fe_ep_enabled">Плагин включен</label>' );
		html += get_form_table_caption( "Выберите, следует ли включать или отключать события, использующие этот плагин, в расписании." );
		html += get_form_table_spacer();
		
		// command
		html += get_form_table_row('Исполняемый файл:', '<textarea id="fe_ep_command" style="width:550px; height:50px; resize:vertical;" spellcheck="false" onkeydown="return $P().stopEnter(this,event)">'+escape_text_field_value(plugin.command)+'</textarea>');
		html += get_form_table_caption(
			'Введите путь к файловой системе вашего исполняемого файла, включая все аргументы командной строки.<br/>' + 
			'Не включайте никаких каналов или перенаправлений — для этого используйте <b>Плагин оболочки</b>.' 
		);
		html += get_form_table_spacer();
		
		// params editor
		html += get_form_table_row( 'Параметры:', '<div id="d_ep_params">' + this.get_plugin_params_html() + '</div>' );
		html += get_form_table_caption( 
			'<div style="margin-top:5px;">Параметры передаются в ваш плагин через JSON и как переменные среды.<br/>' + 
			'Например, вы можете использовать это для настройки переменной PATH, если этого требует ваш плагин.</div>' 
		);
		html += get_form_table_spacer();
		
		// advanced options
		var adv_expanded = !!(plugin.cwd || plugin.uid);
		html += get_form_table_row( 'Дополнительно', 
			'<div style="font-size:13px;'+(adv_expanded ? 'display:none;' : '')+'"><span class="link addme" onMouseUp="$P().expand_fieldset($(this))"><i class="fa fa-plus-square-o">&nbsp;</i>Расширенные настройки</span></div>' + 
			'<fieldset style="padding:10px 10px 0 10px; margin-bottom:5px;'+(adv_expanded ? '' : 'display:none;')+'"><legend class="link addme" onMouseUp="$P().collapse_fieldset($(this))"><i class="fa fa-minus-square-o">&nbsp;</i>Расширенные настройки</legend>' + 
				'<div class="plugin_params_label">Рабочий каталог (CWD):</div>' + 
				'<div class="plugin_params_content"><input type="text" id="fe_ep_cwd" size="50" value="'+escape_text_field_value(plugin.cwd)+'" placeholder="" spellcheck="false"/></div>' + 
				
				'<div class="plugin_params_label">Запуск от имени пользователя (UID):</div>' + 
				'<div class="plugin_params_content"><input type="text" id="fe_ep_uid" size="20" value="'+escape_text_field_value(plugin.uid)+'" placeholder="" spellcheck="false"/></div>' + 
				
			'</fieldset>'
		);
		html += get_form_table_caption(
			"При желании введите путь к рабочему каталогу и/или собственный UID для плагина.<br>" + 
			"UID может быть числовым или строковым («root», «wheel» и т.д.)." 
		);
		html += get_form_table_spacer();
		
		return html;
	},
	
	stopEnter: function(item, e) {
		// prevent user from hitting enter in textarea
		var c = e.which ? e.which : e.keyCode;
		if (c == 13) {
			if (e.preventDefault) e.preventDefault();
			// setTimeout("document.getElementById('"+item.id+"').focus();",0);	
			return false;
		}
	},
	
	get_plugin_params_html: function() {
		// return HTML for editing plugin params
		var params = this.plugin.params;
		var html = '';
		var ctype_labels = this.ctype_labels;
		
		var cols = ['ID параметра', 'Метка', 'Тип управления', 'Описание', 'Действия'];
		
		html += '<table class="data_table" width="100%">';
		html += '<tr><th>' + cols.join('</th><th>').replace(/\s+/g, '&nbsp;') + '</th></tr>';
		for (var idx = 0, len = params.length; idx < len; idx++) {
			var param = params[idx];
			var actions = [
				'<span class="link" onMouseUp="$P().edit_plugin_param('+idx+')"><b>Редактировать</b></span>',
				'<span class="link" onMouseUp="$P().delete_plugin_param('+idx+')"><b>Удалить</b></span>'
			];
			html += '<tr>';
			html += '<td><span class="link" style="font-family:monospace; font-weight:bold; white-space:nowrap;" onMouseUp="$P().edit_plugin_param('+idx+')"><i class="fa fa-cog">&nbsp;&nbsp;</i>' + param.id + '</span></td>';
			// html += '<td><span class="link" style="font-weight:bold" onMouseUp="$P().edit_plugin_param('+idx+')">' + param.title + '</span></td>';
			if (param.title) html += '<td><b>&ldquo;' + param.title + '&rdquo;</b></td>';
			else html += '<td>(н/д)</td>';
			
			html += '<td>' + ctype_labels[param.type] + '</td>';
			
			var pairs = [];
			switch (param.type) {
				case 'text':
					pairs.push([ 'Size', param.size ]);
					if ('value' in param) pairs.push([ 'По умолчанию', '&ldquo;' + param.value + '&rdquo;' ]);
				break;
				
				case 'textarea':
					pairs.push([ 'Строки', param.rows ]);
				break;
				
				case 'checkbox':
					pairs.push([ 'По умолчанию', param.value ? 'Отмечено' : 'Не отмечено' ]);
				break;
				
				case 'hidden':
					pairs.push([ 'Значение', '&ldquo;' + param.value + '&rdquo;' ]);
				break;
				
				case 'select':
					pairs.push([ 'Пункты', '(' + param.items.join(', ') + ')' ]);
					if ('value' in param) pairs.push([ 'По умолчанию', '&ldquo;' + param.value + '&rdquo;' ]);
				break;
			}
			for (var idy = 0, ley = pairs.length; idy < ley; idy++) {
				pairs[idy] = '<b>' + pairs[idy][0] + ':</b> ' + pairs[idy][1];
			}
			html += '<td>' + pairs.join(', ') + '</td>';
			
			html += '<td>' + actions.join(' | ') + '</td>';
			html += '</tr>';
		} // foreach param
		if (!params.length) {
			html += '<tr><td colspan="'+cols.length+'" align="center" style="padding-top:10px; padding-bottom:10px; font-weight:bold;">';
			html += 'Параметры не найдены.';
			html += '</td></tr>';
		}
		html += '</table>';
		
		html += '<div class="button mini" style="width:110px; margin:10px 0 0 0" onMouseUp="$P().edit_plugin_param(-1)">Добавить...</div>';
		
		return html;
	},
	
	edit_plugin_param: function(idx) {
		// show dialog to edit or add plugin param
		var self = this;
		var param = (idx > -1) ? this.plugin.params[idx] : {
			id: "",
			type: "text",
			title: "",
			size: 20,
			value: ""
		};
		this.plugin_param = param;
		
		var edit = (idx > -1) ? true : false;
		var html = '';
		
		var ctype_labels = this.ctype_labels;
		var ctype_options = [
			['text', ctype_labels.text],
			['textarea', ctype_labels.textarea],
			['checkbox', ctype_labels.checkbox],
			['select', ctype_labels.select],
			['hidden', ctype_labels.hidden]
		];
		
		html += '<table>' + 
			get_form_table_row('Параметр ID:', '<input type="text" id="fe_epp_id" size="20" value="'+escape_text_field_value(param.id)+'"/>') + 
			get_form_table_caption("Введите ID параметра, который будет ключом JSON.") + 
			get_form_table_spacer() + 
			get_form_table_row('Метка:', '<input type="text" id="fe_epp_title" size="35" value="'+escape_text_field_value(param.title)+'"/>') + 
			get_form_table_caption("") + 
			// get_form_table_spacer() + 
			// get_form_table_row('Тип управления:', '<select id="fe_epp_ctype" onChange="$P().change_plugin_control_type()">' + render_menu_options(ctype_options, param.type, false) + '</select>') + 
			// get_form_table_caption("Введите метку, которая будет отображаться рядом с элементом управления.") + 
		'</table>';
		
		html += '<fieldset style="margin-top:20px;">';
			html += '<legend><table cellspacing="0" cellpadding="0"><tr><td>Control&nbsp;Type:&nbsp;</td><td><select id="fe_epp_ctype" onChange="$P().change_plugin_control_type()">' + render_menu_options(ctype_options, param.type, false) + '</select></td></tr></table></legend>';
			html += '<div id="d_epp_editor" style="margin:5px 10px 5px 10px;">' + this.get_plugin_param_editor_html() + '</div>';
		html += '</fieldset>';
		
		app.confirm( '<i class="fa fa-cog">&nbsp;&nbsp;</i>' + (edit ? "Редактировать параметр" : "Добавить параметр"), html, edit ? "Хорошо" : "Добавить", function(result) {
			app.clearError();
			
			if (result) {
				param = self.get_plugin_param_values();
				if (!param) return;
				
				if (edit) {
					// edit existing
					self.plugin.params[idx] = param;
				}
				else {
					// add new, check for unique id
					if (find_object(self.plugin.params, { id: param.id })) {
						return add.badField('fe_epp_id', "Этот ID параметра уже занят. Пожалуйста, введите уникальное значение.");
					}
					
					self.plugin.params.push( param );
				}
				
				Dialog.hide();
				
				// refresh param list
				self.refresh_plugin_params();
				
			} // user clicked add
		} ); // app.confirm
		
		if (!edit) setTimeout( function() {
			$('#fe_epp_id').focus();
		}, 1 );
	},
	
	get_plugin_param_editor_html: function() {
		// get html for editing one plugin param, new or edit
		var param = this.plugin_param;
		var html = '<table>';
		
		switch (param.type) {
			case 'text':
				html += get_form_table_row('Размер:', '<input type="text" id="fe_epp_text_size" size="5" value="'+escape_text_field_value(param.size)+'"/>');
				html += get_form_table_caption("Введите размер текстового поля в символах.");
				html += get_form_table_spacer('short transparent');
				html += get_form_table_row('Значение:', '<input type="text" id="fe_epp_text_value" size="35" value="'+escape_text_field_value(param.value)+'" spellcheck="false"/>');
				html += get_form_table_caption("Введите значение по умолчанию для текстового поля.");
			break;
			
			case 'textarea':
				html += get_form_table_row('Строк:', '<input type="text" id="fe_epp_textarea_rows" size="5" value="'+escape_text_field_value(param.rows || 5)+'"/>');
				html += get_form_table_caption("Введите количество видимых строк, которые нужно выделить для текстового поля.");
				html += get_form_table_spacer('short transparent');
				html += get_form_table_row('Текст по умолчанию:', '<textarea id="fe_epp_textarea_value" style="width:99%; height:60px; resize:none;" spellcheck="false">'+escape_text_field_value(param.value)+'</textarea>');
				html += get_form_table_caption("При необходимости введите текст по умолчанию для текстового поля.");
			break;
			
			case 'checkbox':
				html += get_form_table_row('Состояние по умолчанию:', '<select id="fe_epp_checkbox_value">' + render_menu_options([[0,'Не отмечено'], [1,'Отмечено']], param.value, false) + '</select>');
				html += get_form_table_caption("Выберите, должен ли флажок быть изначально установлен или снят.");
			break;
			
			case 'hidden':
				html += get_form_table_row('Значение:', '<input type="text" id="fe_epp_hidden_value" size="35" value="'+escape_text_field_value(param.value)+'" spellcheck="false"/>');
				html += get_form_table_caption("Введите значение скрытого поля.");
			break;
			
			case 'select':
				html += get_form_table_row('Пункты меню:', '<input type="text" id="fe_epp_select_items" size="35" value="'+escape_text_field_value(param.items ? param.items.join(', ') : '')+'" spellcheck="false"/>');
				html += get_form_table_caption("Введите разделенный запятыми список пунктов меню.");
				html += get_form_table_spacer('short transparent');
				html += get_form_table_row('Выбранный элемент:', '<input type="text" id="fe_epp_select_value" size="20" value="'+escape_text_field_value(param.value)+'" spellcheck="false"/>');
				html += get_form_table_caption("При необходимости введите элемент, который будет выбран по умолчанию.");
			break;
		} // switch type
		
		html += '</table>';
		return html;
	},
	
	get_plugin_param_values: function() {
		// build up new 'param' object based on edit form (gen'ed from get_plugin_edit_controls())
		var param = { type: this.plugin_param.type };
		
		param.id = trim( $('#fe_epp_id').val() );
		if (!param.id) return app.badField('fe_epp_id', "Введите ID параметра плагина.");
		if (!param.id.match(/^\w+$/)) return app.badField('fe_epp_id', "ID параметра должен быть буквенно-цифровым.");
		
		param.title = trim( $('#fe_epp_title').val() );
		if ((param.type != 'hidden') && !param.title) return app.badField('fe_epp_title', "Введите метку для параметра плагина.");
		
		switch (param.type) {
			case 'text':
				param.size = trim( $('#fe_epp_text_size').val() );
				if (!param.size.match(/^\d+$/)) return app.badField('fe_epp_text_size', "Введите размер текстового поля.");
				param.size = parseInt( param.size );
				if (!param.size) return app.badField('fe_epp_text_size', "Введите размер текстового поля.");
				if (param.size > 40) return app.badField('fe_epp_text_size', "Размер текстового поля должен быть от 1 до 40 символов.");
				param.value = trim( $('#fe_epp_text_value').val() );
			break;
			
			case 'textarea':
				param.rows = trim( $('#fe_epp_textarea_rows').val() );
				if (!param.rows.match(/^\d+$/)) return app.badField('fe_epp_textarea_rows', "Введите количество строк в текстовое поле.");
				param.rows = parseInt( param.rows );
				if (!param.rows) return app.badField('fe_epp_textarea_rows', "Введите количество строк в текстовое поле.");
				if (param.rows > 50) return app.badField('fe_epp_textarea_rows', "Число строк текстового поля должно быть от 1 до 50.");
				param.value = trim( $('#fe_epp_textarea_value').val() );
			break;
			
			case 'checkbox':
				param.value = parseInt( trim( $('#fe_epp_checkbox_value').val() ) );
			break;
			
			case 'hidden':
				param.value = trim( $('#fe_epp_hidden_value').val() );
			break;
			
			case 'select':
				if (!$('#fe_epp_select_items').val().match(/\S/)) return app.badField('fe_epp_select_items', "Введите список пунктов меню, разделенных запятыми.");
				param.items = trim( $('#fe_epp_select_items').val() ).split(/\,\s*/);
				param.value = trim( $('#fe_epp_select_value').val() );
				if (param.value && !find_in_array(param.items, param.value)) return app.badField('fe_epp_select_value', "Введенное вами значение по умолчанию не найдено в списке пунктов меню.");
			break;
		}
		
		return param;
	},
	
	change_plugin_control_type: function() {
		// change dialog to new control type
		// render, resize and reposition dialog
		var new_type = $('#fe_epp_ctype').val();
		this.plugin_param.type = new_type;
		
		$('#d_epp_editor').html( this.get_plugin_param_editor_html() );
		
		// Dialog.autoResize();
	},
	
	delete_plugin_param: function(idx) {
		// delete selected plugin param, but do not save
		// don't prompt either, giving a UX hint that save did not occur
		this.plugin.params.splice( idx, 1 );
		this.refresh_plugin_params();
	},
	
	refresh_plugin_params: function() {
		// redraw plugin param area after change
		$('#d_ep_params').html( this.get_plugin_params_html() );
	},
	
	get_plugin_form_json: function() {
		// get plugin elements from form, used for new or edit
		var plugin = this.plugin;
		
		plugin.title = trim( $('#fe_ep_title').val() );
		if (!plugin.title) return app.badField('fe_ep_title', "Пожалуйста, введите название плагина.");
		
		plugin.enabled = $('#fe_ep_enabled').is(':checked') ? 1 : 0;
		
		plugin.command = trim( $('#fe_ep_command').val() );
		if (!plugin.command) return app.badField('fe_ep_command', "Введите путь в файловой системе к исполняемой команде плагина.");
		if (plugin.command.match(/[\n\r]/)) return app.badField('fe_ep_command', "Вы не должны включать в свою команду символы новой строки (EOL). Пожалуйста, рассмотрите возможность использования встроенного плагина Shell.");
		
		plugin.cwd = trim( $('#fe_ep_cwd').val() );
		plugin.uid = trim( $('#fe_ep_uid').val() );
		
		if (plugin.uid.match(/^\d+$/)) plugin.uid = parseInt( plugin.uid );
		
		return plugin;
	}
	
});
